============
Contributing
============

First off, thank you for considering contributing to AltWalker.


Did you find a bug?
-------------------

- Ensure the bug was not already reported by searching all `issues`_.
- If you're unable to find an open issue addressing the problem, open a new one and label it with the bug label. Be sure to include a title and clear description, as much relevant information as possible:

  - What version of python are you using?
  - What operating system are you using?
  - What did you do?
  - What did you expect?
  - A code sample or an executable test case demonstrating the expected behavior that is not occurring.

When you ask a question about a problem you will get a much better/quicker answer if you provide a code sample that can be used to reproduce the problem. Try to:

- Use as little code as possible that still produces the same problem.
- Provide all parts needed to reproduce the problem (code and model if needed).
- Test the code you’re about to provide to make sure it reproduces the problem.


How to suggest a feature or enhancement?
----------------------------------------

If you find yourself wishing for a feature that doesn't exist in AltWalker:

- Ensure the enhancement was not already reported by searching all `issues`_.
- Open an issue on our `issues list <issues>`_ and label it with the enhancement label. Be sure to include a clear description of the feature you would like to see, as much relevant information as possible:

  - Why you need it?
  - How should it work?


You need your custom executor?
------------------------------

You can implement your own custom test execution by implementing a server for the executor's http protocol.

Check `How to: Write your own executor <https://altom.gitlab.io/altwalker/altwalker/how-tos/custom-executor.html>`_ section.


Submit an executor in another language?
---------------------------------------

If you've implemented your own custom test executor in a language that is not already supported by AltWalker `Contact us <altwalker@altom.com>`_ and will help you integrate it.


.. _issues: https://gitlab.com/altom/altwalker/altwalker/issues/